=== debian/changelog ===
gfal2 (2.2.1-2) unstable; urgency=low

  * Workaraond for no dirent d_off on hurd and kfreebsd

 -- Mattias Ellert <mattias.ellert@fysast.uu.se>  Sun, 05 May 2013 15:50:21 +0200

gfal2 (2.2.1-1) unstable; urgency=low

  * New upstream release
  * Workaround missing ECOMM on hurd and kfreebsd

 -- Mattias Ellert <mattias.ellert@fysast.uu.se>  Fri, 03 May 2013 18:55:59 +0200
